#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# A compatibility layer between FXRuby 1.0.x and 1.2.x                          #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: compatibility.rb,v 1.2 2004/07/12 08:44:37 leikind Exp $                 #
#*******************************************************************************#

begin
    require "fox"
    #raise LoadError.new
rescue LoadError
    log("could not load fxruby, trying to load via RubyGems")
    begin
        require "rubygems"
        require_gem "fxruby"
    rescue
        log($!.message)
        STDERR.puts "Could not load FXRuby - FoX bindings for Ruby."
        exit 1
    end
end

version = Fox::fxrubyversion
log("running with FXRuby version " + version)

if version[0..2] == "1.2"
    $FXRUBY_VERSION_1_2 = true
else    
    $FXRUBY_VERSION_1_2 = false
end

if $FXRUBY_VERSION_1_2
    module Fox
    
        FXMenubar = FXMenuBar
        FXToolbarShell = FXToolBarShell
        FXToolbarGrip = FXToolBarGrip
        FXTooltip = FXToolTip
        FXToolbar = FXToolBar
        FXStatusbar = FXStatusBar
        FXStatusline = FXStatusLine
        
        
        module ArgumentListCutter
            def init(args)
                if args.size >= 2
                    args = args[0..(@start-1)] + args[(@start+@count)..-1]
                end
                initialize_original(*args)
            end            
        end
        
        class FXList
            include ArgumentListCutter
            alias_method(:initialize_original, :initialize)            
            def initialize(*args)
                @start = 1
                @count = 1
                init(args)
            end
        end
        
        class FXComboBox
            alias_method(:initialize_original, :initialize)        
            include ArgumentListCutter
            def initialize(*args)
                @start = 2
                @count = 1
                init(args)
            end
        end
        
        
        class FXStatusbar
            alias_method(:statusline, :statusLine) 
        end
        
        class FXDCWindow
            alias_method(:setTextFont, :setFont)
        end
    end
end

