#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# Application Toolkit: Application configuration code                           #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: configuration.rb,v 1.5 2004/07/09 16:11:14 leikind Exp $                 #
#*******************************************************************************#

require "yaml"

module AppToolkit

    class Config
    
        def initialize(dir, fname)
            @dir = ENV["HOME"] + "/" + dir
            @filename = fname
    
            unless FileTest.exist?(@dir)
                Dir.mkdir(@dir)
            end
        
            unless FileTest.exist?(@dir + "/" + @filename)
                File.open(@dir+ "/" + @filename, "w"){|f|
                    a = { "d" => "k"}
                    f.puts a.to_yaml
                }
            end
        
            @options = YAML::load(File.open(@dir + "/" + @filename))
        end
    
        def [](key)
            @options[key]
        end
    
        def delete(key)
            @options.delete(key)
        end
    
        def []=(key, value)
            @options[key] = value
        end
    
        def dump
            log("saving settings")
            File.open(@dir + "/" + @filename, "w"){|f|
                f.puts @options.to_yaml
                #puts @@options.to_yaml
            }
        end
    end
end

if $0 == __FILE__
    AppToolkit::Config.new(".test", "configg")
end

