#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# Application Toolkit: Main window class                                        #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: main_window.rb,v 1.6 2004/07/09 16:11:14 leikind Exp $                   #
#*******************************************************************************#

module AppToolkit
    class MainWindow < Fox::FXMainWindow

        include Fox

        TITLE      = "Application"
        ICON       = nil
        MINIICON   = nil
        OPTS       = DECOR_ALL
        X          = 100
        Y          = 100
        WIDTH      = 700
        HEIGHT     = 500
        PAD_LEFT   = 0
        PAD_RIGHT  = 0
        PAD_TOP    = 0
        PAD_BOTTOM = 0
        H_SPACING  = 4
        V_SPACING  = 4
        SBAR_TEXT = "Ready."
        
        attr_reader :mt
        

        def initialize(app, resources, icons, sbar_text_key = nil)

            @app = app
            x = @app.config["x"] || X
            y = @app.config["y"] || Y
            width = @app.config["width"] || WIDTH
            height = @app.config["height"] || HEIGHT
            
            super(app, app.title, ICON, MINIICON, OPTS, x, y, width, height, PAD_LEFT,
                  PAD_RIGHT, PAD_TOP, PAD_BOTTOM, H_SPACING, V_SPACING)
            
            app.set_window(self)
            @resources = resources
            @mt = MenubarAndToolbar.new(self, @resources, icons)

            @statusbar = FXStatusbar.new(self, LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|STATUSBAR_WITH_DRAGCORNER)
            
            if sbar_text_key.nil?
                @statusbar.statusline.normalText = SBAR_TEXT
            else
                @statusbar.statusline.normalText = @resources[sbar_text_key]
                @statusbar.statusline.easinstaller_text_key = {"normalText=" => sbar_text_key}
            end
        end
    end
end
