#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# Application Toolkit: Message class                                            #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: message.rb,v 1.5 2004/07/06 15:23:37 leikind Exp $                       #
#*******************************************************************************#

module AppToolkit

    class Message < AppToolkit::Dialog
        include Fox

        ERROR = "error"
        INFORMATION = "information"
        WARNING = "warning"
        QUESTION = "question"

        PWD = Dir.pwd

        @@icons = {}

        def initialize(parent, type, message, caption = nil)
            icon = get_icon(type)

            caption = type.capitalize if caption.nil?
            #super(parent, caption)
            
            actions = {
                AppToolkit::Dialog::OK => Proc.new{}
            }
            
            super(parent, caption, 0, 0, actions)

            info = FXHorizontalFrame.new(@content,LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FILL_X|LAYOUT_FILL_Y,
                0,0,0,0,10,10,10,10);

            FXLabel.new(info,nil,icon,JUSTIFY_LEFT|ICON_BEFORE_TEXT|LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FILL_X|LAYOUT_FILL_Y)
            FXLabel.new(info,message,nil,
                JUSTIFY_LEFT|ICON_BEFORE_TEXT|LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FILL_X|LAYOUT_FILL_Y)
            FXHorizontalSeparator.new(@content,SEPARATOR_GROOVE|LAYOUT_TOP|LAYOUT_LEFT|LAYOUT_FILL_X)
        end



        def get_icon(type)
            unless @@icons.has_key?(type)
                File.open(PWD + "/icons/" + type + ".gif", "rb"){|f|
                    @@icons[type] =  Fox::FXGIFIcon.new(UI::EasinstallerApp.get_app, f.read)
                }
            end
            @@icons[type]
        end
    end

end

