#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# Sudo and su related routines                                                  #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: auth.rb,v 1.4 2004/07/05 13:38:58 leikind Exp $                         #
#*******************************************************************************#


module Core
    module Auth
    
        def self.valid_password?(password)
            command = "expect -c 'spawn -noecho su -c \"echo\"; log_user 0 ; " +
                "expect \"Password: \"; send \"#{password}\\r\" ;  " +
                "expect \"su: Authentication failure\" { exit 24 } '"
            Kernel.system(command)
        end
    
    
        def self.tempdir_wrapper
            Dir.chdir("/tmp"){
                yield
            }
        end
    
        def self.sudo_expects_password?(cmd)
            erase_sudo_timestamp()
            command = "expect -c 'spawn -noecho sudo #{cmd}; log_user 0; expect \"Password:\" { exit 5 }'"
            not system(command)
        end
    
        def self.erase_sudo_timestamp
            system("sudo -k")
        end
        
        def self.sudo_allows_command?(cmd, password)
            command = nil
            if sudo_expects_password?(cmd)
                command = "echo \"#{password}\" | sudo -S #{cmd} 2>&1"
            else
                command = "sudo -S #{cmd} 2>&1"
            end
            tempdir_wrapper{
                pipe = IO.popen(command)
                while line = pipe.gets
                    #puts line.dump
                    if line =~ /is not allowed to execute/
                        return false
                    end
                end
            }
            return true
        end
        
        def self.sudo_validate_password?(cmd, password)
            erase_sudo_timestamp()
            tempdir_wrapper{
                command = "echo \"#{password}\" | sudo -S #{cmd} 2>&1"
                pipe = IO.popen(command)
                while line = pipe.gets
                    if line =~ /^sudo: \d incorrect password attempt/
                        return false
                    end
                end
            }
            return true
        end
        
        hook(UI::Signals::ValidPassword){|emmitter, password|
            valid_password?(password)
        }

        INSTALL_COMMAND = "make install"
        
        hook(UI::Signals::PasswordRequiredForSudo){
            sudo_expects_password?(INSTALL_COMMAND)
        }

        hook(UI::Signals::SudoAllowsCommand){|emmiter, password|
            sudo_allows_command?(INSTALL_COMMAND, password)
        }

        
        hook(UI::Signals::IsPasswordValidForSudo){|emmiter, password|
            if sudo_expects_password?(INSTALL_COMMAND)
                sudo_validate_password?(INSTALL_COMMAND, password)
            else
                true
            end
        }        
    end
end


