#*******************************************************************************#
#                                                                               #
#                            E A S I N S T A L L E R                            #
#                                                                               #
# A signals register for AppToolkit signalling infrastructure                   #
#*******************************************************************************#
# Copyright (C) 2004 by Yuri Leikind.                                           #
#*******************************************************************************#
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public                           #
# License as published by the Free Software Foundation                          #
#                                                                               #
# This program is distributed in the hope that it will be useful,               #
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             #
# General Public License for more details.                                      #
#                                                                               #
# You should have received a copy of the GNU General Public                     #
# License along with this program; if not, write to the Free Software           #
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    #
#*******************************************************************************#
# $Id: signals.rb,v 1.4 2004/07/06 15:22:44 leikind Exp $                       #
#*******************************************************************************#

require "app_toolkit/signals.rb"

module UI
	module Signals
	
		include AppToolkit::Signals
		
		class NewSessionPossible < BaseSignal; end
		class NewSessionStarted < BaseSignal; end
	
		class LoadSettings < BaseSignal; end
	
		class OptionsParsed < BaseSignal; end
		class RunConfigure < BaseSignal; end
		class ConfigureFinished < BaseSignal; end
		class ConfigureFailed < BaseSignal; end
		class RunBuild < BaseSignal; end
		class BuildFinished < BaseSignal; end
		class RunInstall < BaseSignal; end
		class InstallFinished < BaseSignal; end
	
		class ShuttingDown < BaseSignal; end
		class NewCommand < BaseSignal; end
		class CommandFinished < BaseSignal; end
		class ConsoleLine < BaseSignal; end
		class ConsoleLineStdOut < ConsoleLine; end
		class ConsoleLineStdErr < ConsoleLine; end
	
		# requests
		class LocalInstallation < BaseSignal; end
		class ValidPassword < BaseSignal; end
		
		class PasswordRequiredForSudo < BaseSignal; end
		class IsPasswordValidForSudo < BaseSignal; end
		class SudoAllowsCommand < BaseSignal; end
	end
end

